//---------------------------------------------------------------------------
//       :                 Simplex.cpp
//   :      TSimplex
//           :        
//           :   -
//    :   Windows NT4.0 / Windows 95/98
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "TSimplex.h"
#pragma package(smart_init)

//----------------------------------------------------------------------------
//----------------------     TSimplexTable -----------------------
//----------------------------------------------------------------------------
//         
// M -    
// N -    
__fastcall TSimplexTable::TSimplexTable(int M, int N, int* BaseVars, int* FreeVars)
{
 int i,j;         //  
 CountRows = M;   // -    (   )
 CountCols = N;   // -    (   )
 FreeIndex = 0;   //   ,     
 BaseIndex = 0;   //   ,     

                        //      
 Matrix = new double*[CountRows];     //     
 for(i = 0; i < CountRows; i++)       //    
   Matrix[i] = new double[CountCols]; //      
 for(i = 0; i < CountRows; i++)
  for(j = 0; j < CountCols; j++)
    Matrix[i][j] = 0;                 //   
                        //      
 LowMatrix = new double*[CountRows];     //     
 for(i = 0; i < CountRows; i++)          //    
   LowMatrix[i] = new double[CountCols]; //      
 for(i = 0; i < CountRows; i++)
  for(j = 0; j < CountCols; j++)
    LowMatrix[i][j] = 33;                 //   

 BaseIndexes = new int[CountRows-1];    //       
 if(BaseVars)
  for(i = 0; i < CountRows-1; i++)       //     
//   BaseIndexes[i] = CountCols+i;
   BaseIndexes[i] = BaseVars[i];
 FreeIndexes = new int[CountCols-1];    //       
 if(FreeVars)
  for(j = 0; j < CountCols-1; j++)       //     
//  FreeIndexes[j] = j+1;
   FreeIndexes[j] = FreeVars[j];
}
//----------------------------------------------------------------------------
//      
__fastcall TSimplexTable::~TSimplexTable()
{
 int i;         //  
                        //   -   
 for(i = 0; i < CountRows; i++)    //    
      delete []Matrix[i];          //    
 delete []Matrix;                  //   
                        //   -   
 for(i = 0; i < CountRows; i++)    //    
      delete []LowMatrix[i];       //    
 delete []LowMatrix;               //   

 delete []FreeIndexes;          //     
 delete []BaseIndexes;          //     
}
//----------------------------------------------------------------------------
//  -   
void __fastcall TSimplexTable::Assign(double** SourceMatrix)
{
 int i,j;         //  
 for(i = 0; i < CountRows; i++)
   for(j = 0; j < CountCols; j++)
     Matrix[i][j] = SourceMatrix[i][j];
}
//----------------------------------------------------------------------------
//   -  - - 
void __fastcall TSimplexTable::Copy(TSimplexTable* DestTable)
{
 int i,j;
 if( (CountRows != DestTable->CountRows)|| //      ()
     (CountCols != DestTable->CountCols)
   ) return;
 DestTable->Assign(Matrix);                //  
 for(i = 0; i < CountRows-1; i++)                 //     
   DestTable->BaseIndexes[i] = BaseIndexes[i];
 for(j = 0; j < CountCols-1; j++)                 //     
   DestTable->FreeIndexes[j] = FreeIndexes[j];
}
//----------------------------------------------------------------------------
//  -
//  :
// 1  -  ,   
// 0  -   ,   
// -1 -   
int __fastcall TSimplexTable::CulcNextTable()
{
 int countneg;                   // -       ( )
 bool Res;                       //       
 int tmp;
 int i,j;

 countneg = 0;                  //  -       
 for(j = 0; j < CountCols-1; j++)  //  -       
                                   //  .( )  
   if(Matrix[CountRows-1][j] <= 0) countneg++;
 if(countneg == CountCols-1)      //        
        return 0;                 //    

 Res = CulcLowTable(); //      

 if(Res)                             //   
 {      //  -      
                //   ,  
   OldFreeIndex = FreeIndexes[FreeIndex];
   OldBaseIndex = BaseIndexes[BaseIndex];
          //     
   tmp = FreeIndexes[FreeIndex];
   FreeIndexes[FreeIndex] = BaseIndexes[BaseIndex];
   BaseIndexes[BaseIndex] = tmp;
         //         
         //     
   for(i = 0; i < CountRows; i++)
     Matrix[i][FreeIndex] = LowMatrix[i][FreeIndex];
   for(j = 0; j < CountCols; j++)
     Matrix[BaseIndex][j] = LowMatrix[BaseIndex][j];
        //   -         
   for(i = 0; i < CountRows; i++)
     for(j = 0; j < CountCols; j++)
       if( (i!=BaseIndex) && (j!=FreeIndex) )
         Matrix[i][j] = Matrix[i][j] + LowMatrix[i][j];
 }
 if(Res) return 1;                  //  
 else    return -1;                 //   
}
//----------------------------------------------------------------------------
//      -
bool __fastcall TSimplexTable::CulcLowTable()
{
  double min;           //       
  double GenElement;    //  
  double maxnonzero;
  int countneg;
  int i,j;

  maxnonzero = 0;       //      
         //          ( )
         //  .   ( )
  for(j = 0; j < CountCols-1; j++)
   if(Matrix[CountRows-1][j] > maxnonzero)
     { FreeIndex = j;                     //   ,   
       maxnonzero = Matrix[CountRows-1][j];//  
     }
 if(maxnonzero==0)      //      
        return false;
        //       
  countneg = 0;
  for(i = 0; i < CountRows; i++)
   if(Matrix[i][FreeIndex] <= 0) countneg++;
  if(countneg == CountRows)     //       
        return false;           //    

        //   
  min = MaxInt;
  for(i = 0; i< CountRows-1; i++)
   if( (Matrix[i][FreeIndex]>0) && (Matrix[i][CountCols-1]>0) ) //    
    if(Matrix[i][CountCols-1]/Matrix[i][FreeIndex] < min) //   
      { BaseIndex = i;         //   ,   
        min = Matrix[i][CountCols-1]/Matrix[i][FreeIndex]; //  
      }
  GenElement = Matrix[BaseIndex][FreeIndex];
            //      
  LowMatrix[BaseIndex][FreeIndex] = 1/Matrix[BaseIndex][FreeIndex]; //  
  for(j = 0; j < CountCols; j++)        //  
   if( j!= FreeIndex)                  //     
     LowMatrix[BaseIndex][j] = Matrix[BaseIndex][j] / GenElement;
  for(i = 0; i < CountRows; i++)        //  
    if(i != BaseIndex)                  //     
      LowMatrix[i][FreeIndex] = -(Matrix[i][FreeIndex] / GenElement);
  for(i = 0; i < CountRows; i++)        //   
    for(j = 0; j < CountCols; j++)      // 
     if( (i!=BaseIndex)&&(j!=FreeIndex))
       LowMatrix[i][j] = LowMatrix[i][FreeIndex] * Matrix[BaseIndex][j];
  return true;
}
//----------------------------------------------------------------------------
//----------------------     TSimplex ----------------------------
//----------------------------------------------------------------------------
//   
__fastcall TSimplex::TSimplex()
{
  Tables = new TList;   //     
  Tables->Clear();
}
//----------------------------------------------------------------------------
//   
__fastcall TSimplex::~TSimplex()
{
 int i;
        //       -
 for(i = 0; i< Tables->Count; i++) //     -
     if(Tables->Items[i] != NULL) delete (TSimplexTable*)(Tables->Items[i]);
 if(Tables) delete []Tables; //   -  -
}
//----------------------------------------------------------------------------
//   -,   
// SourceTable -  ,    
// M - -  
// N - -  
//  -     
//             -1    
bool __fastcall TSimplex::Execute(double** SourceTable, int M, int N, int* BaseVars, int* FreeVars, int* Steps)
{
 int CanGo;                     //      - 
 TSimplexTable* ThisTable;       //  -

 TSimplexTable* Table;           //  -
 Table = new TSimplexTable(M, N, BaseVars, FreeVars); //   -
 Table->Assign(SourceTable);     //  -   
 Tables->Add(Table);             //     -
 do
 {
   ThisTable = new TSimplexTable(M,N,BaseVars,FreeVars);
   Table->Copy(ThisTable);
   CanGo = ThisTable->CulcNextTable();
   if(CanGo==1)
    { Table = ThisTable;
      Tables->Add(Table);             //     -
    }
   else
     if(ThisTable) delete ThisTable;  //        
 } while (CanGo);

 *Steps = Tables->Count;
 if(CanGo == -1) return false;
 return true;
}
//-------------------------------------------------------------------------------
//  -     Step (   0)
double** __fastcall TSimplex::GetTable(int Step)
{
 if(Step >= Tables->Count) return NULL;
 return ((TSimplexTable*)(Tables->Items[Step]))->Matrix;
}
//-------------------------------------------------------------------------------
//    -    Step (   0)
double** __fastcall TSimplex::GetLowTable(int Step)
{
 if(Step >= Tables->Count) return NULL;
 if( ! ((TSimplexTable*)(Tables->Items[Step]))->CulcLowTable() )
   return NULL;
 return ((TSimplexTable*)(Tables->Items[Step]))->LowMatrix;
}
//-------------------------------------------------------------------------------
//         Step(   0)
int* __fastcall TSimplex::GetFreeVars(int Step)
{
 if(Step >= Tables->Count) return NULL;
 return ( (TSimplexTable*)(Tables->Items[Step]) )->FreeIndexes;      //  
}
//-------------------------------------------------------------------------------
//         Step(   0)
int* __fastcall TSimplex::GetBaseVars(int Step)
{
 if(Step >= Tables->Count) return NULL;
 return ( (TSimplexTable*)(Tables->Items[Step]) )->BaseIndexes;      //  
}
//-------------------------------------------------------------------------------
//         
void __fastcall TSimplex::GetIndexes(int Step, int* OldBase, int* OldFree)
{
 if(Step >= Tables->Count) return;
 *OldBase = ( (TSimplexTable*)(Tables->Items[Step]) )->OldBaseIndex;
 *OldFree = ( (TSimplexTable*)(Tables->Items[Step]) )->OldFreeIndex;
}
//-------------------------------------------------------------------------------
//         
void __fastcall TSimplex::GetGeneralRC(int Step, int* Row, int* Col)
{
 if(Step >= Tables->Count) return;
 *Row = ( (TSimplexTable*)(Tables->Items[Step]) )->BaseIndex;
 *Col = ( (TSimplexTable*)(Tables->Items[Step]) )->FreeIndex;

}



