//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  int R;
  double** mas;
  int i, j, k;
  int* FreeVars;
  int* BaseVars;

  double** c;
  double* a, *b;

  M = StrToInt(CSEM->Text);     //  
  N = StrToInt(CSEN->Text);     //  
  R = M + N - 1;                //  
  CountFreeVars = M * N - R;    // -  
  CountBaseVars = M + N - 1;    // -  

        //    
  mas = new double*[CountBaseVars+1];
  for(i = 0;i < CountBaseVars + 1; i++)
    mas[i] = new double[CountFreeVars+1];
  if (!InputMas(mas,c,a,b))   //   mas
  {
    ShowMessage("   !!!");
    return;
  }
        //     
  FreeVars = new int[CountFreeVars];
  k = 0;
  for(i = 0;i < CountBaseVars; i++)
   for(j = 0; j < CountBaseVars; j++)
    { FreeVars[k] = i*CountFreeVars+j+1;
      k++;
    }
        //     
  BaseVars = new int[CountBaseVars];
  for(j = 0; j < CountFreeVars; j++)
    BaseVars[j] = j+1;
  k = CountFreeVars-1;
  for(i = 1; i < CountBaseVars; i++)
    { BaseVars[k] = i* CountFreeVars+1;
      k++;
    }

  Simplex = new TSimplex();

  Simplex->Execute(mas, CountBaseVars, CountFreeVars, BaseVars, FreeVars, &StepsCount);
}
//---------------------------------------------------------------------------
bool __fastcall TForm1::InputMas(double** mas, double** c, double* a, double* b)
{
  int i, j;
  double tmp1, tmp2; 
        //      ( 0) (  )
  for(j=0;j<CountFreeVars;j++)
   mas[0][j] = -1;
        //     1  N-1 (  )
  for(i = 1; i < N; i++)
    for(j = 0;j < CountFreeVars; j++)
      if(j*(N-1)+i-1 < CountFreeVars)
        mas[i][j*(N-1)+i-1] = 1;

        //      N..CountBaseVars-1
  for(i = N; i < CountBaseVars; i++)
    for(j = (i-N)*(N-1); j < (i-N)*(N-1)+N-1; j++)
     mas[i][j] =1;
        //       1..N-1
  for(i = 1; i < N; i++)
    mas[i][CountFreeVars] = b[i];
        //       N..CountBaseVars-1
  for(i = N; i < CountBaseVars; i++)
    mas[i][CountFreeVars] = a[i-N+1];
        //     ( 0) 
  tmp1 = 0;
  for(i = 1; i < M; i++)
   tmp1 += a[i];
  mas[0][CountFreeVars] = b[0]-tmp1;
        //        
  for(i = 1; i < M; i++)
   for(j = 1; j < N; j++)
    mas[CountBaseVars][(i-1)*M+j-1] = c[0][0] - c[i][0] - c[0][j] + c[i][j];
        //     
  tmp2 = 0;
  for(j = 1; j < N; j++)
    tmp2 += c[0][j]*b[j];
  for(i = 1; i < M; i++)
    tmp2 += c[i][0]*a[i];
  tmp2 += c[0][0]*(b[0]-tmp1);
  mas[CountBaseVars][CountFreeVars] = tmp2;
}
//----------------------------------------------------------------------------
//   
void __fastcall TForm1::Matrix()
{
  SBRez->DisableAutoRange();
  if (StepsCount == -1) return;
  int WidthOld = 0;
//    
  int CWidth   = 64;//SGA->DefaultColWidth;
  CWidth       = CWidth*(CountI + 1) + 15;
  int CHeight  = 24;//SGA->DefaultRowHeight;
  CHeight      = CHeight*(CountJ*2 + 2)+10;
  PRez->Top    = CHeight;
  PRez->Height = CHeight + 40;

//      
  double** MasRez;
  int * MasXX;
  int * MasYY;
  for (int st = 0; st < StepsCount; st++)
  {
    SGRez = new TStringGrid(SBRez->Handle);
    SGRez->Parent = SBRez;

    SGRez->Left   = WidthOld;
    SGRez->Width  = WidthOld + CWidth;
    SGRez->Top    = 0;
    SGRez->Height = CHeight;
    WidthOld      = WidthOld + CWidth + 1;

    SGRez->ColCount  = CountI + 1; //M * N - N + 1; //SGA->ColCount;
    SGRez->RowCount  = (M + N +1) * 2 + 1; //(SGBegin->RowCount-1)*2 + 1;
    SGRez->FixedCols = 1;
    SGRez->FixedRows = 1;
    SGRez->Options<<goFixedVertLine<<goFixedHorzLine<<goVertLine<<goHorzLine<<goRangeSelect;
    SGRez->Visible   = true;
    SGRez->Align     = alNone;
    SGRez->Tag       = st;
    SGRez->OnDrawCell= MyDrawCell;

    RxL = new TRxLabel(PRez);
    RxL->Parent = PRez;
    RxL->Top    = 5;
    RxL->Height = 10;
    RxL->Left   = SGRez->Left + 50;
    RxL->Width  = 100;

    RxL1 = new TRxLabel(PRez);
    RxL1->Parent = PRez;
    RxL1->Top    = 20;
    RxL1->Height = 10;
    RxL1->Left   = SGRez->Left + 50;
    RxL1->Width  = 100;

//     
    double** MasRezLo;

    MasRez  = Simplex->GetTable(st);
    MasRezLo= Simplex->GetLowTable(st);
    MasXX    = Simplex->GetFreeVars(st);
    MasYY    = Simplex->GetBaseVars(st);

    for(int j = 1; j <= CountI - 1; j++)
     SGRez->Cells[j][0] = "X" + IntToStr(MasXX[j-1]);
    SGRez->Cells[CountI][0] = ".";

    int m = 0;
    int j = 1;
    while (j <= CountJ*2 - 1)
    {
      SGRez->Cells[0][j] = "X" + IntToStr(MasYY[m]);
      m++;
      j += 2;
    }
    SGRez->Cells[0][CountJ*2-1] = "F";

//  -
    for(int i = 1; i <= CountI; i++)
    {
      j = 1; m = 0;
      while (j <= CountJ*2 - 1)
      {
        SGRez->Cells[i][j] = FormatFloat("0.000", MasRez[m][i-1]);
        j += 2; m++;
      }
    }

    RxL->Caption = "F = " + SGRez->Cells[CountI][CountJ*2 - 1];
    int k,r;
    k = 0; r = 0;
    if (st + 1 != StepsCount)
    {
      Simplex->GetIndexes(st+1, &k, &r);
      RxL1->Caption = "X" + IntToStr(k) + " <--> X" + IntToStr(r);
    }
// -
    if (MasRezLo == NULL) continue;
    for(int i = 1; i <= CountI; i++)
    {
      j = 2; m = 0;
      while (j <= CountJ*2 )
      {
        SGRez->Cells[i][j] = FormatFloat("0.000", MasRezLo[m][i-1]);
        j += 2; m++;
      }
    }
  }//   
  RxL1 = new TRxLabel(PRez);
  RxL1->Parent = PRez;
  RxL1->Top    = 50;
  RxL1->Height = 30;
  RxL1->Left   = 50;
  RxL1->Width  = 100;
  RxL1->Font->Color  = clGreen;

  AnsiString Prib = SGRez->Cells[CountI][CountJ*2 - 1];
  if (Prib.Pos("-") != 0)
  {
    Prib.Delete(1,1);
  }
  RxL1->Caption = " = " + Prib;

  RxL1 = new TRxLabel(PRez);
  RxL1->Parent = PRez;
  RxL1->Top    = 70;
  RxL1->Height = 30;
  RxL1->Left   = 50;
  RxL1->Width  = 100;
  RxL1->Font->Color  = clGreen;

  AnsiString Rez = "";
  bool flag;
  int g,d;
  for (g = 1; g < CountI; g++)
   {
    flag = false;
    for (int d = 0; d < CountI; d++)
     if (MasXX[d] == g)
      {
        Rez += "X" + IntToStr(g) + " = 0; ";
        flag = true;
        break;
      }
    if(flag) continue;
    for (d = 0; d < CountJ; d++)
      if (MasYY[d] == g)
      {
        Rez += "X" + IntToStr(g) + " = " + FormatFloat("0.000", MasRez[d][CountI-1]) + "; ";
      }
    }
  RxL1->Caption = " : " + Rez;
  SBRez->EnableAutoRange();
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

//  StringGrid
void __fastcall TForm1::MyDrawCell(TObject *Sender, int Col, int Row, const TRect &Rect, TGridDrawState State)
{
  TStringGrid *MySGRez = NULL;
  MySGRez = dynamic_cast<TStringGrid*>(Sender);
  if (MySGRez->Tag + 1 == StepsCount) return;
  int k, r;
  Simplex->GetGeneralRC(MySGRez->Tag, &k, &r);
  if (MySGRez->Tag == 0)
  {
    MySGRez->Canvas->Brush->Color = clGreen;
  }
  if ( (r + 1 == Col) || (k * 2 + 1 == Row) )
  {
    MySGRez->Canvas->Brush->Color = clGreen;
    MySGRez->Canvas->FillRect(Rect);

    MySGRez->Canvas->Font->Color = clYellow;
    MySGRez->Canvas->TextOut(Rect.Left+5, Rect.Top+5, MySGRez->Cells[Col][Row]);
  }
    if (State.Contains(gdFocused))
      MySGRez->Canvas->DrawFocusRect(Rect);
}
//---------------------------------------------------------------------------

